MARTe2-core - User story #197

Implement AnyType data conversions.
19.08.2015 15:01 - Riccardo Vitelli

Status: Closed Start date: 19.08.2015
Priority: Normal Due date:
Assignee: % Done: 0%
Category: Estimated time: 0.00 hour
Target version: 0.5 Spent time: 0.00 hour
Git branch (link): SVN commit

(link/?p=rev):
Git merge to develop
(link):
Description

Implement the AnyType data conversions required for the implementation of the printf and to be able to convert between any type to

any type.
In particular the implementation must support the construction of an AnyType from a class registered in the database.

It was decided to rename BitSize to NumberOfBits in all the relevant files.

Source code files modified

e Source/Core/L0TypeDev/AnyType.h
Source/Core/L0TypeDev/BitBoolean.h
Source/Core/L0TypeDev/BitRange.h
Source/Core/L0TypeDev/FormatDescriptor.h
Source/Core/L0TypeDev/Fractionallnteger.h
Source/Core/L0TypeDev/TypeDescriptor.h
Source/Core/L10bjects/ClassProperties.cpp
Source/Core/L10bjects/ClassProperties.h
Source/Core/L10bjects/ClassRegistryDatabase.cpp
Source/Core/L10bjects/ClassRegistryDatabase.h
Source/Core/L10bjects/ClassRegistryltem.cpp
Source/Core/L10bjects/ClassRegistryltem.h
Source/Core/L10bjects/Object.h
Test/Core/LOTypeDev/AnyTypeTest.cpp
Test/Core/L0TypeDev/AnyTypeTest.h
Test/Core/L0TypeDev/BitBooleanTest.h
Test/Core/L0TypeDev/BitRangeTest.h
Test/Core/L0TypeDev/FractionallntegerTest.h
Test/Core/L10bjects/ClassPropertiesTest.cpp
Test/Core/L10bjects/ClassPropertiesTest.h
Test/Core/L10bjects/ClassRegistryDatabaseTest.cpp
Test/Core/L10bjects/ClassRegistryDatabaseTest.h
Test/Core/L10bjects/ClassRegistryltemTest.cpp
Test/Core/L10bjects/ClassRegistryltemTest.h

Architecture & design review
Date of the review: 08/09/2015
Person who did the review: Andre' Neto

Version of architecture & design document: N/A. As per the original MARTe implementation, this is a support function and does
not require formal design in UML.

Result of review: N/A

List of non-conformities: N/A
Code and documentation review
Date of the review: 25/09/2015

Person who did the review: Riccardo Vitelli

Result of review: PASS

List of non-conformities: N/A.

Unit test review

Date of the review: 28/09/2015

Person who did the review: Lloren¢ Capella

Result of coverage tests review: PASS

Note: The coverage of the ClassRegistryDatabase is not 100%
Result of functional tests review: PASS

Result of review: PASS

List of non-conformities: N/A

Associated revisions

Revision c6a8773d - 17.09.2015 18:18 - André Neto

#197 Implemented the construction of an AnyType from an Object.

Finished the implementation of AnyType from Object. With this method it
now possible to generate an AnyType from any class that has been
registered in the ClassRegistryDatabase. Consequently, this has required
supporting the registration of typeid(class).name() in the
ClassRegistryDatabase.

As part of this development, BitSize was renamed to GetNumberOfBits in
BitBoolean, BitRange and Fractionallnteger.

There were missing unit tests in AnyType which were also created.

Revision 0f12a363 - 18.09.2015 10:45 - André Neto
#197 Added the TemplateParametersVerificator.

Added to BitRange, BitBoolean and Fractionalinteger the
TemplateParametersVerificator. This allows to guarantee at compilation
time that the templates are called with the correct parameters.

Revision 0f3624ca - 23.09.2015 14:28 - André Neto
#197 Moved to folder structure defined in #226.

Revision 912a4791 - 23.09.2015 16:22 - André Neto

Merge remote-tracking branch 'origin/#226_Folder_Restructuring' into
#197_Any_Type_Conversion

Conflicts:

EclipseLint.sh
MakeDefaults/Lint/marte_flint_base_configuration.Int
Source/Core/BareMetal/L0Types/BasicType.h
Source/Core/BareMetal/LO0Types/BitBoolean.h
Source/Core/BareMetal/L0Types/BitRange.h
Source/Core/BareMetal/LOTypes/ErrorType.h
Source/Core/BareMetal/L0Types/FlagsType.h
Source/Core/BareMetal/LO0Types/Fractionallnteger.h
Source/Core/BareMetal/LOTypes/Introspection.h
Source/Core/BareMetal/L0Types/Iterator.h
Source/Core/BareMetal/LOTypes/IteratorT.h
Source/Core/BareMetal/LOTypes/LinkedListHolder.cpp
Source/Core/BareMetal/L0Types/LinkedListHolder.h
Source/Core/BareMetal/LOTypes/LinkedListable.cpp
Source/Core/BareMetal/LO0Types/LinkedListable.h
Source/Core/BareMetal/LO0Types/SearchFilter.h
Source/Core/BareMetal/LO0Types/SearchFilterT.h
Source/Core/BareMetal/L0Types/SortFilter.h
Source/Core/BareMetal/LOTypes/SortFilterT.h
Source/Core/BareMetal/L0Types/StructuredData.h
Source/Core/BareMetal/L0Types/TypeCharacteristics.h
Source/Core/BareMetal/LOTypes/TypeDescriptor.h
Source/Core/BareMetal/L1Portability/Architecture/x86_gcc/AtomicA.h
Source/Core/BareMetal/L1Portability/Architecture/x86_gcc/EndianityA.h
Source/Core/BareMetal/L1Portability/Architecture/x86_gcc/FastMathA.h
Source/Core/BareMetal/L1Portability/Architecture/x86_gcc/HighResolutionTimerA.h
Source/Core/BareMetal/L1Portability/Architecture/x86_gcc/ProcessorA.h
Source/Core/BareMetal/L1Portability/Atomic.h
Source/Core/BareMetal/L1Portability/BasicConsole.h
Source/Core/BareMetal/L1Portability/Endianity.h
Source/Core/BareMetal/L1Portability/Environment/Generic/MemoryOperationsHelper_CLIB_Generic.cpp
Source/Core/BareMetal/L1Portability/Environment/Generic/StandardHeap_Generic.cpp
Source/Core/BareMetal/L1Portability/Environment/Generic/StandardHeap_Generic.h
Source/Core/BareMetal/L1Portability/Environment/Generic/StringHelperExtras_Generic.cpp
Source/Core/BareMetal/L1Portability/Environment/Generic/StringHelper_CLIB_Generic.cpp
Source/Core/BareMetal/L1Portability/Environment/Generic/StringHelper_Portable_Generic.cpp
Source/Core/BareMetal/L1Portability/Environment/Linux/BasicConsole.cpp
Source/Core/BareMetal/L1Portability/Environment/Linux/GeneralDefinitions.h
Source/Core/BareMetal/L1Portability/Environment/Linux/HighResolutionTimer.h
Source/Core/BareMetal/L1Portability/Environment/Linux/HighResolutionTimerCalibrator.cpp
Source/Core/BareMetal/L1Portability/Environment/Linux/HighResolutionTimerCalibrator.h
Source/Core/BareMetal/L1Portability/Environment/Linux/LoadableLibrary.cpp
Source/Core/BareMetal/L1Portability/Environment/Linux/StandardHeap.h
Source/Core/BareMetal/L1Portability/Environment/Linux/lint-linux.h
Source/Core/BareMetal/L1Portability/Errorinformation.h
Source/Core/BareMetal/L1Portability/ErrorManagement.cpp
Source/Core/BareMetal/L1Portability/ErrorManagement.h
Source/Core/BareMetal/L1Portability/FastMath.h
Source/Core/BareMetal/L1Portability/FastPollingMutexSem.h
Source/Core/BareMetal/L1Portability/FormatDescriptor.cpp
Source/Core/BareMetal/L1Portability/FormatDescriptor.h
Source/Core/BareMetal/L1Portability/Heapl.h
Source/Core/BareMetal/L1Portability/HeapManager.cpp
Source/Core/BareMetal/L1Portability/HeapManager.h
Source/Core/BareMetal/L1Portability/LoadableLibrary.h
Source/Core/BareMetal/L1Portability/MemoryCheck.h
Source/Core/BareMetal/L1Portability/MemoryOperationsHelper.h
Source/Core/BareMetal/L1Portability/Processor Type.cpp
Source/Core/BareMetal/L1Portability/ProcessorType.h
Source/Core/BareMetal/L1Portability/Sleep.h
Source/Core/BareMetal/L1Portability/StringHelper.cpp
Source/Core/BareMetal/L1Portability/StringHelper.h
Source/Core/BareMetal/L1Portability/TimeoutType.h
Source/Core/BareMetal/L20bjects/ClassProperties.cpp
Source/Core/BareMetal/L20bjects/ClassProperties.h
Source/Core/BareMetal/L20bjects/ClassRegistryDatabase.cpp
Source/Core/BareMetal/L20bjects/ClassRegistryDatabase.h
Source/Core/BareMetal/L20bjects/ClassRegistryltem.cpp
Source/Core/BareMetal/L20bjects/ClassRegistryltem.h
Source/Core/BareMetal/L20bjects/Object.cpp
Source/Core/BareMetal/L20bjects/Object.h
Source/Core/BareMetal/L20bjects/Reference.cpp
Source/Core/BareMetal/L20bjects/Reference.h
Source/Core/BareMetal/L20bjects/ReferenceContainer.cpp
Source/Core/BareMetal/L20bjects/ReferenceContainer.h
Source/Core/BareMetal/L20bjects/ReferenceContainerFilter.cpp
Source/Core/BareMetal/L20bjects/ReferenceContainerFilter.h
Source/Core/BareMetal/L20bjects/ReferenceContainerFilterObjectName.cpp
Source/Core/BareMetal/L20bjects/ReferenceContainerFilterObjectName.h
Source/Core/BareMetal/L20bjects/ReferenceContainerFilterReferences.cpp
Source/Core/BareMetal/L20bjects/ReferenceContainerFilterReferences.h
Source/Core/BareMetal/L20bjects/ReferenceContainerNode.cpp
Source/Core/BareMetal/L20bjects/ReferenceContainerNode.h
Source/Core/BareMetal/L20bjects/ReferenceT.cpp
Source/Core/BareMetal/L20bjects/ReferenceT.h
Source/Core/BareMetal/L3Streams/AnyType.h
Source/Core/Scheduler/L1Portability/Environment/Generic/ThreadsDatabase_Generic.cpp
Source/Core/Scheduler/L1Portability/Environment/Generic/ThreadsDatabase_Generic.h
Source/Core/Scheduler/L1Portability/Environment/Linux/EventSem.cpp
Source/Core/Scheduler/L1Portability/Environment/Linux/MutexSem.cpp
Source/Core/Scheduler/L1Portability/Environment/Linux/Processor.cpp
Source/Core/Scheduler/L1Portability/Environment/Linux/Threads.cpp
Source/Core/Scheduler/L1Portability/Environment/Windows/Sleep.cpp
Source/Core/Scheduler/L1Portability/EventSem.h
Source/Core/Scheduler/L1Portability/ExceptionHandler.h
Source/Core/Scheduler/L1Portability/MutexSem.h
Source/Core/Scheduler/L1Portability/Processor.h
Source/Core/Scheduler/L1Portability/ThreadIinformation.cpp
Source/Core/Scheduler/L1Portability/Threadinformation.h
Source/Core/Scheduler/L1Portability/Threads.h
Test/Core/BareMetal/L0Types/BasicTypeTest.cpp
Test/Core/BareMetal/L0Types/BitBooleanTest.h
Test/Core/BareMetal/L0Types/BitRangeTest.h
Test/Core/BareMetal/L0Types/FractionallntegerTest.h
Test/Core/BareMetal/LOTypes/LinkedListHolderTest.cpp
Test/Core/BareMetal/L0Types/LinkedListHolderTest.h
Test/Core/BareMetal/LOTypes/LinkedListableTest.cpp
Test/Core/BareMetal/LOTypes/LinkedListableTest.h
Test/Core/BareMetal/LOTypes/ListTestHelper.h
Test/Core/BareMetal/L0Types/TypeCharacteristicsTest.cpp
Test/Core/BareMetal/LO0Types/TypeDescriptorTest.cpp
Test/Core/BareMetal/L0Types/TypeDescriptorTest.h
Test/Core/BareMetal/L1Portability/AtomicTest.h
Test/Core/BareMetal/L1Portability/AuxHeap.cpp
Test/Core/BareMetal/L1Portability/AuxHeap.h
Test/Core/BareMetal/L1Portability/BasicConsoleTest.cpp
Test/Core/BareMetal/L1Portability/BasicConsoleTest.h
Test/Core/BareMetal/L1Portability/Endianity Test.h
Test/Core/BareMetal/L1Portability/ErrorManagementTest.cpp
Test/Core/BareMetal/L1Portability/ErrorManagementTest.h
Test/Core/BareMetal/L1Portability/FastMathTest.h
Test/Core/BareMetal/L1Portability/FastPollingMutexSemTest.h
Test/Core/BareMetal/L1Portability/FormatDescriptorTest.cpp
Test/Core/BareMetal/L1Portability/FormatDescriptorTest.h
Test/Core/BareMetal/L1Portability/HeapManagerTest.cpp
Test/Core/BareMetal/L1Portability/HeapManagerTest.h
Test/Core/BareMetal/L1Portability/HighResolutionTimerTest.cpp
Test/Core/BareMetal/L1Portability/HighResolutionTimerTest.h
Test/Core/BareMetal/L1Portability/LoadableLibraryTest.cpp
Test/Core/BareMetal/L1Portability/LoadableLibraryTest.h
Test/Core/BareMetal/L1Portability/MemoryCheckTest.cpp
Test/Core/BareMetal/L1Portability/MemoryIntegrationTest.h
Test/Core/BareMetal/L1Portability/MemoryOperationsHelperTest.cpp
Test/Core/BareMetal/L1Portability/MemoryTest.h
Test/Core/BareMetal/L1Portability/ProcessorTypeTest.h
Test/Core/BareMetal/L1Portability/SleepTest.cpp
Test/Core/BareMetal/L1Portability/SleepTest.h
Test/Core/BareMetal/L1Portability/StandardHeap_GenericTest.cpp
Test/Core/BareMetal/L1Portability/StandardHeap_GenericTest.h
Test/Core/BareMetal/L1Portability/StringHelperTest.h
Test/Core/BareMetal/L1Portability/StringPortableTest.h
Test/Core/BareMetal/L1Portability/StringTestHelper.h
Test/Core/BareMetal/L1Portability/ TimeoutTypeTest.cpp
Test/Core/BareMetal/L1Portability/TimeoutTypeTest.h
Test/Core/BareMetal/L20bjects/ClassPropertiesTest.cpp
Test/Core/BareMetal/L20bjects/ClassPropertiesTest.h
Test/Core/BareMetal/L20bjects/ClassRegistryDatabaseTest.cpp
Test/Core/BareMetal/L20bjects/ClassRegistryDatabaseTest.h
Test/Core/BareMetal/L20bjects/ClassRegistryltemTest.cpp
Test/Core/BareMetal/L20bjects/ClassRegistryltemTest.h
Test/Core/BareMetal/L20bjects/ObjectTest.h
Test/Core/BareMetal/L20bjects/ObjectTestHelper.h
Test/Core/BareMetal/L20bjects/ReferenceContainerFilterObjectNameTest.h
Test/Core/BareMetal/L20bjects/ReferenceContainerFilterReferencesTest.cpp
Test/Core/BareMetal/L20bjects/ReferenceContainerFilterReferencesTest.h
Test/Core/BareMetal/L20bjects/ReferenceContainerNodeTest.cpp
Test/Core/BareMetal/L20bjects/ReferenceContainerTest.h
Test/Core/BareMetal/L20bjects/ReferenceTTest.cpp
Test/Core/BareMetal/L20bjects/ReferenceTTest.h
Test/Core/BareMetal/L20bjects/ReferenceTest.cpp
Test/Core/BareMetal/L20bjects/ReferenceTest.h
Test/Core/BareMetal/L20bjects/TestObjectHelper1.h
Test/Core/BareMetal/L20bjects/TestObjectHelper2.h
Test/Core/BareMetal/L3Streams/AnyTypeTest.cpp
Test/Core/BareMetal/L3Streams/AnyTypeTest.h
Test/Core/Scheduler/L1Portability/EventSemTest.cpp
Test/Core/Scheduler/L1Portability/EventSemTest.h
Test/Core/Scheduler/L1Portability/MutexSemTest.cpp
Test/Core/Scheduler/L1Portability/MutexSemTest.h
Test/Core/Scheduler/L1Portability/ProcessorTest.cpp
Test/Core/Scheduler/L1Portability/ProcessorTest.h
Test/Core/Scheduler/L1Portability/ThreadsTest.h
Test/GTest/AnyTypeGTest.cpp
Test/GTest/BitBooleanGTest.cpp
Test/GTest/BitRangeGTest.cpp

Revision 817a80a7 - 23.09.2015 16:53 - André Neto
#197 Finished merging with #226 for new folder structure.

History

#1 - 08.09.2015 12:54 - André Neto
- Description updated
- Status changed from New to Code: Impl

- Target version changed from Backlog to 0.5

#2 - 16.09.2015 15:30 - André Neto

- Assignee set to André Neto

#3 - 16.09.2015 15:32 - André Neto

- Description updated

#4 - 17.09.2015 18:29 - André Neto

- Description updated

- Status changed from Code: Impl to Code: Rev
- Assignee deleted (André Neto)

#5 - 18.09.2015 16:58 - Riccardo Vitelli

- Assignee set to Riccardo Vitelli

#6 - 25.09.2015 16:37 - Riccardo Vitelli

- Description updated

#7 - 25.09.2015 16:38 - Riccardo Vitelli
- Status changed from Code: Rev to Unit: Impl

#8 - 25.09.2015 16:38 - Riccardo Vitelli
- Assignee deleted (Riccardo Vitelli)

#9 - 28.09.2015 09:50 - Llorenc Capella

- Assignee set to Llorenc Capella

#10 - 28.09.2015 10:58 - Llorenc Capella
- Status changed from Unit: Impl to Unit: Rev

#11 - 28.09.2015 17:01 - Llorenc Capella
- Status changed from Unit: Rev to Unit: Impl

#12 - 28.09.2015 17:01 - Llorenc Capella
- Status changed from Unit: Impl to Unit: Rev
#13 - 28.09.2015 17:06 - Llorenc Capella
- Description updated

- Assignee deleted (Llorenc Capella)

#14 - 28.09.2015 18:13 - Ivan Herrero

- Status changed from Unit: Rev to Closed

Merged on develop.

#15 - 29.09.2015 09:51 - Ivan Herrero

- Description updated
